//////////////////////////////////////////////////////////////////////
// graphics sample
//////////////////////////////////////////////////////////////////////

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <NDS.h>

// 荞݃nh
void InterruptHandler(void)
{
	if (REG_IF & IRQ_VBLANK) {
		VBLANK_INTR_WAIT_FLAGS |= IRQ_VBLANK;
		REG_IF |= IRQ_VBLANK;
	}
	REG_IF = REG_IF;
}

/* bitmap _` */
void bmp_pset( u16* bmp, int x, int y, u16 col )
{
	bmp[y*256+x] = col;
}
void WaitForVBlank()
{
	while(!(REG_DISPSTAT & DISP_IN_VBLANK));
	while((REG_DISPSTAT & DISP_IN_VBLANK));
}
int main(void)
{
	int i,j;

	// 荞ݐݒ
	REG_IME = 0;
	IRQ_HANDLER = &InterruptHandler;
	REG_IE = IRQ_VBLANK;
	REG_IF = ~0;
	REG_DISPSTAT = DISP_VBLANK_IRQ;
	REG_IME = 1;

	// MAIN,SUB̉ʃ[hݒ
	videoSetMode   (MODE_5_2D | DISPLAY_BG2_ACTIVE | DISPLAY_BG3_ACTIVE);
	videoSetModeSub(MODE_5_2D | DISPLAY_BG2_ACTIVE );

	// VRAM̃oNݒ
    vramSetBankA(VRAM_A_MAIN_BG);	/* bank A MAINBG 0x06000000Ɋ蓖Ă */
    vramSetBankB(VRAM_B_MAIN_BG);	/* bank B MAINBG 0x06020000Ɋ蓖Ă */
    vramSetBankC(VRAM_C_SUB_BG );	/* bank C SUB BG 0x06200000Ɋ蓖Ă */

	// BG̐ݒ
	BG2_CR     = BG_BMP16_256x256 | BG_BMP_BASE(0) | BG_WRAP_ON;	// 16bitJ[BITMAPbAhX0x6000000b[[v
	BG3_CR     = BG_BMP16_256x256 | BG_BMP_BASE(8) | BG_WRAP_ON;	// 16bitJ[BITMAPbAhX0x6020000b[[v
	SUB_BG2_CR = BG_BMP16_256x256 | BG_BMP_BASE(0) | BG_WRAP_ON;	// 16bitJ[BITMAPbAhX0x6200000b[[v

	// pbgݒ
	BG_PALETTE    [0] = RGB15(0,8,8);  // wiF
	BG_PALETTE_SUB[0] = RGB15(8,0,8);  // wiF

	// BITMAP AhX擾
	u16 * MBG2 = (u16*)BG_BMP_RAM(0);
	u16 * MBG3 = (u16*)BG_BMP_RAM(8);
	u16 * SBG2 = (u16*)BG_BMP_RAM_SUB(0);

	// NA
	memset( MBG2, 0, 256*256*2 );
	memset( MBG3, 0, 256*256*2 );
	memset( SBG2, 0, 256*256*2 );

	// _`
	for( i=0;i<200; i++ ){
		bmp_pset(MBG2, rand()%256,rand()%256, 0xFFFF );
		bmp_pset(MBG3, rand()%256,rand()%256, 0xEED5 );
		bmp_pset(SBG2, rand()%256,rand()%256, 0x85DD );
	}

	// lp
/*
	for( i=50;i<100;i++ ){
		for( j=60;j<150;j++ ){
			bmp_pset(SBG2, j, i, 0xFFFF  );
		}
	}
*/
	// XN[ݒ
    BG2_XDX = 1 << 8;
    BG2_XDY = 0;
    BG2_YDX = 0;
    BG2_YDY = 1 << 8;
	BG2_CX = 0;
	BG2_CY = 0;

    BG3_XDX = 1 << 8;
    BG3_XDY = 0;
    BG3_YDX = 0;
    BG3_YDY = 1 << 8;
	BG3_CX = 0;
	BG3_CY = 0;

    SUB_BG2_XDX = 1 << 8;
    SUB_BG2_XDY = 0;
    SUB_BG2_YDX = 0;
    SUB_BG2_YDY = 1 << 8;
	SUB_BG2_CX = 1 << 8;
	SUB_BG2_CY = 1 << 8;

	// KɃXN[
	u8 cnt = 0;
	uint16 x1=0,x2=0,x3=0;
	uint16 y1=0,y2=0,y3=0;
	uint16 dx1=0,dx2=0,dx3=0;
	uint16 dy1=0,dy2=0,dy3=0;
//	int deg = 0;
//	int scl = 0;
    while(1){
		swiWaitForVBlank();
		BG2_CX     = x1;			// BGx_Cx += xx; ƂȂ܂삵Ȃ
		BG2_CY     = y1;
		BG3_CX     = x2;
		BG3_CY     = y2;
		SUB_BG2_CX = x3;
		SUB_BG2_CY = y3;
/*
		scl ++;
		SUB_BG2_XDX =  COS[ deg ];
		SUB_BG2_XDY = -SIN[ deg ];
		SUB_BG2_YDX =  SIN[ deg ];
		SUB_BG2_YDY =  COS[ deg ];
*/
		x1 += dx1;
		y1 += dy1;
		x2 += dx2;
		y2 += dy2;
		x3 += dx3;
		y3 += dy3;
//		deg += 1;
//		if( deg == 360 ) deg = 0;
		if( !cnt ){
			dx1 = rand()%200-100;
			dy1 = rand()%200-100;
			dx2 = rand()%200-100;
			dy2 = rand()%200-100;
			dx3 = rand()%200-100;
			dy3 = rand()%200-100;
		}
		cnt++;
    }  
	return 0;
}
